Bug 690038 - Review Request: ompl - The Open Motion Planning Library
Review Request: ompl - The Open Motion Planning Library
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Martin Gieseking
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2011-03-23 01:32 EDT by Rich Mattes
Modified: 2011-08-02 22:32 EDT (History)
4 users (show)

See Also:
Fixed In Version: ompl-0.9.3-2.fc15
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-08-02 22:26:34 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
martin.gieseking: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Rich Mattes 2011-03-23 01:32:17 EDT
Spec URL: http://rmattes.fedorapeople.org/RPMS/ompl/ompl.spec
SRPM URL: http://rmattes.fedorapeople.org/RPMS/ompl/ompl-0.9.2-1.fc15.src.rpm
Description: 
The Open Motion Planning Library (OMPL) consists of many state-of-the-art
sampling-based motion planning algorithms. OMPL itself does not contain
any code related to, e.g., collision checking or visualization. This is
a deliberate design choice, so that OMPL is not tied to a particular
collision checker or visualization front end.

Scratch build: 
http://koji.fedoraproject.org/koji/taskinfo?taskID=2935340

rpmlint:
$ rpmlint ompl.spec ../RPMS/x86_64/ompl*
ompl.x86_64: E: invalid-soname /usr/lib64/libompl.so libompl.so
3 packages and 1 specfiles checked; 1 errors, 0 warnings.

Upstream doesn't include a soversion.  It looks like they recently removed it (going from 0.9.1 to 0.9.2,) I will ask why.
Comment 1 David Robinson 2011-04-14 16:54:32 EDT
Hi Rich,

Just doing an informal review to help my case of being sponsored :-)

**: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.[1]

[zxvdr@laptop SRPMS]$ rpmlint ompl-0.9.2-1.fc15.src.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

[zxvdr@laptop x86_64]$ rpmlint ompl-0.9.2-1.fc15.x86_64.rpm 
ompl.x86_64: E: invalid-soname /usr/lib64/libompl.so libompl.so
1 packages and 0 specfiles checked; 1 errors, 0 warnings.

The missing soversion is a blocker - it needs to be fixed.

OK: The package must be named according to the Package Naming Guidelines .
OK: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. [2] .
OK: The package must meet the Packaging Guidelines .
OK: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
OK: The License field in the package spec file must match the actual license. [3]
OK: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.[4]
OK: The spec file must be written in American English. [5]
OK: The spec file for the package MUST be legible. [6]
OK: The sources used to build the package must match the upstream source, as provided in the spec URL.

[zxvdr@laptop SOURCES]$ md5sum ompl-0.9.2-Source.tar.gz 
70ce9020edca3e6cec8ea070d390ba9e  ompl-0.9.2-Source.tar.gz
[zxvdr@laptop SOURCES]$ wget http://downloads.sourceforge.net/project/ompl/ompl-0.9.2-Source.tar.gz -q -O - | md5sum
70ce9020edca3e6cec8ea070d390ba9e  -

OK: The package MUST successfully compile and build into binary rpms on at least one primary architecture. [7]
OK: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. 
**: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.

README.txt specifies that Boost 1.42 or higher and CMake 2.8.2 or higher are dependencies - BuildRequires should reflect this, eg:
BuildRequires: cmake >= 2.8.2
BuildRequires: boost >= 1.42

NA: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.[9]
OK: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. [10]
OK: Packages must NOT bundle copies of system libraries.[11]
NA: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package.
OK: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. [13]
OK: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)[14]
OK: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line. [15]
OK: Each package must consistently use macros. [16]
OK: The package must contain code, or permissable content. [17]
OK: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. 
OK: If a package includes something as %doc, it must not affect the runtime of the application. 
OK: Header files must be in a -devel package. [19]
NA: Static libraries must be in a -static package. [20]
**: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package. [19]

Missing soversion...

OK: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release} [21]
OK: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.[20]
NA: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section.
OK: Packages must not own files or directories already owned by other packages.
OK: All filenames in rpm packages must be valid UTF-8. [24]

The SHOULD's:

NA: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it. [25]
NA: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available. [26]
OK: The reviewer should test that the package builds in mock. [27]
OK: The package should compile and build into binary rpms on all supported architectures. [28]
OK: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.

Built the demos against the installed libraries, and they work fine.

[zxvdr@laptop bin]$ ./demo_ODERigidBodyPlanning > /dev/null
[zxvdr@laptop bin]$ echo $?
0

NA: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity. [29]
NA: Usually, subpackages other than devel should require the base package using a fully versioned dependency. [21]
NA: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. 
NA: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself. [31]
NA: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.[32]
Comment 2 Martin Gieseking 2011-04-16 03:33:11 EDT
I agree that the library must get a valid soname, escpecially as previous releases had one.

Here are some additional notes:
- adapt Source0 according to 
  http://fedoraproject.org/wiki/Packaging/SourceURL#Sourceforge.net
  => drop "project" from the path

- Add a comment about what the patch does. You should also ask upstream to 
  apply the patch to the sources 
  http://fedoraproject.org/wiki/PackagingGuidelines#All_patches_should_have_an_upstream_bug_link_or_comment

- the devel package contains a lot of unused directories that should be 
  dropped: %{_includedir}/ompl/CMakeFiles and below

- please be more verbose in %files:
  %{_libdir}/*.so  => %{_libdir}/libompl.so
  %{_includedir}/* => %{_includedir}/%{name}/

- As BuildRoot is missing, you probably don't intend to build the package for
  EPEL < 6. Thus, also drop the %clean section (not required any longer).

- The tarball contains Python bindings for the library. You should think about
  adding them to a python subpackage.
Comment 3 Rich Mattes 2011-04-24 15:08:08 EDT
Update:
Spec URL: http://rmattes.fedorapeople.org/RPMS/ompl/ompl.spec
SRPM URL: http://rmattes.fedorapeople.org/RPMS/ompl/ompl-0.9.2-2.fc15.src.rpm

I contacted upstream about the soname, they accidentally omitted it from the release.  I've patched in a library version and soversion consistent with what will be added in future releases.

The python bindings can't be built without pygccxml and pyplusplus.  Neither of these python modules are packaged in Fedora.

The file lists have been made more specific, and I've fixed the download path.

I've removed the clean section, el5 doesn't have the required dependencies to build this package (cmake 2.8 being one.)  I've also added versioning for cmake and boost deps

rpmlint:
$ rpmlint ompl.spec ../RPMS/x86_64/ompl*
3 packages and 1 specfiles checked; 0 errors, 0 warnings.

Scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=3022644
Comment 4 Martin Gieseking 2011-04-27 10:06:27 EDT
(In reply to comment #3)
> I contacted upstream about the soname, they accidentally omitted it from the
> release.  I've patched in a library version and soversion consistent with what
> will be added in future releases.

OK, that's great. However, is the soversion really supposed to be identical to the package version, i.e. does the library's ABI change with every new release? In this case, all potential packages depending on this library had do be rebuilt every time you update the package. This seems to be a bit odd.

 
> The python bindings can't be built without pygccxml and pyplusplus.  Neither of
> these python modules are packaged in Fedora.

Ah, right. 

The package looks good now and could be approved. However, please ask upstream to shed some light on their soname scheme, as it could cause some problems in the future.
Comment 5 Rich Mattes 2011-04-28 23:00:15 EDT
(In reply to comment #4)
> (In reply to comment #3)
> > I contacted upstream about the soname, they accidentally omitted it from the
> > release.  I've patched in a library version and soversion consistent with what
> > will be added in future releases.
> 
> OK, that's great. However, is the soversion really supposed to be identical to
> the package version, i.e. does the library's ABI change with every new release?
> In this case, all potential packages depending on this library had do be
> rebuilt every time you update the package. This seems to be a bit odd.
> 
> 
> > The python bindings can't be built without pygccxml and pyplusplus.  Neither of
> > these python modules are packaged in Fedora.
> 
> Ah, right. 
> 
> The package looks good now and could be approved. However, please ask upstream
> to shed some light on their soname scheme, as it could cause some problems in
> the future.


I think you're mixing up VERSION and SOVERSION.  The VERSION property dictates what the library file is actually named: in this case, it's tied to the full version number of the project, so the library is named libompl.so.0.9.2.  The name of the library doesn't have anything to do with soname dependencies however.  The SONAME property is set to the project's major version, which is just 0.  You can check using objdump:

$ objdump -p /usr/lib64/libompl.so.0.9.2 |grep SONAME
  SONAME               libompl.so.0

This SONAME is what defines the ABI version, and won't change under this scheme until the project bumps it major version number.  Major version changes usually imply ABI changes anyway, but up until the major project version changes, any dependencies won't need a rebuild when ompl is updated.
Comment 6 Rich Mattes 2011-05-24 17:47:57 EDT
Updated to release 0.9.3:

Spec URL: http://rmattes.fedorapeople.org/RPMS/ompl/ompl.spec
SRPM URL: http://rmattes.fedorapeople.org/RPMS/ompl/ompl-0.9.3-1.fc15.src.rpm

Scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=3091028

rpmlint:
$ rpmlint ompl.spec ../RPMS/x86_64/ompl-*
3 packages and 1 specfiles checked; 0 errors, 0 warnings.
Comment 7 Martin Gieseking 2011-07-20 03:49:34 EDT
Sorry for the delay. I've been rather busy in the last few month.
You're right, I somehow mixed up the definitions of soname and soversion. I'm sorry for that too.
 
Your latest package currently fails building because of missing BR: python:
http://koji.fedoraproject.org/koji/taskinfo?taskID=3213719

Everything else looks fine.


$ rpmlint ompl-*.rpm
4 packages and 0 specfiles checked; 0 errors, 0 warnings.
---------------------------------
key:

[+] OK
[.] OK, not applicable
[X] needs work
---------------------------------

[+] MUST: The package must be named according to the Package Naming Guidelines.
[+] MUST: The spec file name must match the base package %{name}.
[+] MUST: The package must meet the Packaging Guidelines.
[+] MUST: The package must be licensed with a Fedora approved license.
    - BSD (3-clause variant)

[+] MUST: The License field in the package spec file must match the actual license.
[+] MUST: The file containing the text of the license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source.
    $ md5sum ompl-0.9.3-Source.tar.gz*
    b95b4b3a6eebc15a668a52a133384cc1  ompl-0.9.3-Source.tar.gz
    b95b4b3a6eebc15a668a52a133384cc1  ompl-0.9.3-Source.tar.gz.1

[+] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
[.] MUST: If the package does not successfully compile, build or work on an architecture, ...
[X] MUST: All build dependencies must be listed in BuildRequires.
    BR: python is missing

[+] MUST: When compiling C, C++, or Fortran files, %{optflags} must be applied.
[.] MUST: The spec file MUST handle locales properly.
[+] MUST: Packages storing shared library files (not just symlinks) must call ldconfig in %post and %postun.
[+] MUST: Packages must NOT bundle copies of system libraries.
[.] MUST: If the package is designed to be relocatable, ...
[+] MUST: A package must own all directories that it creates. 
[+] MUST: A Fedora package must not list a file more than once in %files.
[+] MUST: Permissions on files must be set properly.
[+] MUST: Each package must consistently use macros.
[+] MUST: The package must contain code, or permissable content.
[.] MUST: Large documentation files must go in a -doc subpackage.
[+] MUST: Files in %doc must not affect the runtime of the application.
[+] MUST: Header files must be in a -devel package.
[.] MUST: Static libraries must be in a -static package.
[+] MUST: library files that end in .so (without suffix) must go in a -devel package.
[+] MUST: devel packages must require the base package using a fully versioned dependency.
[+] MUST: Packages must NOT contain any .la libtool archives.
[.] MUST: Packages containing GUI applications must include a %{name}.desktop file.
[+] MUST: Packages must not own files or directories already owned by other packages.
[+] MUST: All filenames in rpm packages must be valid UTF-8.

[.] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[+] SHOULD: Patch files should be prefixed with %{name}-
[+] SHOULD: All patches should be commented in the spec file
[+] SHOULD: The reviewer should test that the package builds in mock.
[+] SHOULD: The reviewer should test that the package functions as described.
[+] SHOULD: If scriptlets are used, those scriptlets must be sane.
[.] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[.] SHOULD: pkgconfig(.pc) files should be placed in a -devel pkg.
[.] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin ...
[.] SHOULD: Your package should contain man pages for binaries/scripts.
Comment 8 Rich Mattes 2011-07-21 01:38:03 EDT
No need to apologize, and thanks for taking on this review!

I've added the python BR and updated the spec and srpm.  You can find them at:

Spec URL: http://rmattes.fedorapeople.org/RPMS/ompl/ompl.spec
SRPM URL: http://rmattes.fedorapeople.org/RPMS/ompl/ompl-0.9.3-2.fc15.src.rpm

rpmlint:
$ rpmlint ompl.spec ../RPMS/x86_64/ompl*
3 packages and 1 specfiles checked; 0 errors, 0 warnings.


scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=3217638
Comment 9 Martin Gieseking 2011-07-21 02:42:42 EDT
OK, the package looks good now.

----------------
Package APPROVED
----------------
Comment 10 Rich Mattes 2011-07-21 10:59:33 EDT
New Package SCM Request
=======================
Package Name: ompl
Short Description: The Open Motion Planning Library
Owners: rmattes
Branches: f14 f15
InitialCC:
Comment 11 Jon Ciesla 2011-07-21 11:11:56 EDT
Git done (by process-git-requests).
Comment 12 Fedora Update System 2011-07-22 19:59:53 EDT
ompl-0.9.3-2.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/ompl-0.9.3-2.fc14
Comment 13 Fedora Update System 2011-07-22 20:00:02 EDT
ompl-0.9.3-2.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/ompl-0.9.3-2.fc15
Comment 14 Fedora Update System 2011-07-25 23:43:13 EDT
ompl-0.9.3-2.fc14 has been pushed to the Fedora 14 testing repository.
Comment 15 Fedora Update System 2011-08-02 22:26:26 EDT
ompl-0.9.3-2.fc14 has been pushed to the Fedora 14 stable repository.
Comment 16 Fedora Update System 2011-08-02 22:32:09 EDT
ompl-0.9.3-2.fc15 has been pushed to the Fedora 15 stable repository.

Note You need to log in before you can comment on or make changes to this bug.